#include "forms.h"
#include "keeton.h"

/*** callbacks and freeobj handles for form Keeton ***/

double NGALMAX, rscale, gridlo1, gridhi1, gridlo2, gridhi2;
double ngrid1, ngrid2, nsubg1, nsubg2, gridflag;
double omitcore, omitcrit, checkgaps, maxlev, gallev, imglev;
double critmode, crittol, galcoords, shrcoords, maxshear, maxrgstr;
double potflag, xtol, inttol, catalog, nobflip, intshrmode, seed;
double omega, lambda, hval, hvale, tscale, zlens, zsrc;
double verbose, fluxweight, weakweight, checkparity, chimode, srcmode;
double optmode, vertmode, xfloor, xceil, ftol, restart, upenalty;
double linparms, nopointchi, chiperpoint, tempfiles;

void variable_1(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Maximum number of galaxies in a model \n");
  
  NGALMAX = atof(fl_get_input(ob));
  
  printf("NGALMAX = %g \n", NGALMAX);
}

void variable_2(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  
  printf("Sets radial scale of grid \n");

  rscale = atof(fl_get_input(ob));

  printf("rscale = %g \n", rscale);
}

void variable_3(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Grid radius: lower limit (units of rscale) \n");
  
  gridlo1 = atof(fl_get_input(ob));
  
  printf("gridlo1 = %g \n", gridlo1);
}

void variable_4(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Grid radius: upper limit (units of rscale) \n");
  
  gridhi1 = atof(fl_get_input(ob));
  
  printf("gridhi1 = %g \n", gridhi1);
}

void variable_5(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Grid angle:  lower limit \n");

  gridlo2 = atof(fl_get_input(ob));

  printf("gridlo2 = %g \n", gridlo2);
}

void variable_6(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Grid angle:  upper limit \n");

  gridhi2 = atof(fl_get_input(ob));
  
  printf("gridhi2 = %g \n", gridhi2);
}

void variable_7(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("dimension of top grid (radius) \n");
  
  ngrid1 = atof(fl_get_input(ob));
  
  printf("ngrid1 = %g \n", ngrid1);
}

void variable_8(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("dimension of top grid (angle) \n");
  
  ngrid2 = atof(fl_get_input(ob));
  
  printf("ngrid2 = %g \n", ngrid2);
}

void variable_9(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Flag for whether to compute grid \n");
  
  gridflag = atof(fl_get_input(ob));
  
  printf("gridflag = %g \n", gridflag);
}

void variable_10(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  
  printf("dimension of sub grid (radius) \n");

  nsubg1 = atof(fl_get_input(ob));
  
  printf("nsubg1 = %g \n", nsubg1);
}

void variable_11(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("dimension of sub grid (angle) \n");

  nsubg2 = atof(fl_get_input(ob));
  
  printf("nsubg2 = %g \n", nsubg2);
}

void variable_12(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Size of omitted region around galaxies \n");

  omitcore = atof(fl_get_input(ob));

  printf("omitcore = %g \n", omitcore);
}

void variable_13(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Magnification of omitted band around crit crv \n");
  
  omitcrit = atof(fl_get_input(ob));
  
  printf("omitcrit = %g \n", omitcrit);
}

void variable_14(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Flag for checking gaps in source plane grid \n");
  
  checkgaps = atof(fl_get_input(ob));

  printf("checkgaps = %g \n", checkgaps);
}

void variable_15(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Deepest level of subgrid near critical curves \n");
  
  maxlev = atof(fl_get_input(ob));
  
  printf("maxlev = %g \n", maxlev);
}

void variable_16(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Deepest level of subgrid near galaxies \n");

  gallev = atof(fl_get_input(ob));
  
  printf("gallev = %g \n", gallev);
}

void variable_17(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Deepest level of subgrid near images \n");

  imglev = atof(fl_get_input(ob));
  
  printf("imglev = %g \n", imglev);
}

void variable_18(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Compute lensing potential? \n");
  
  potflag = atof(fl_get_input(ob));
  
  printf("potflag = %g \n", potflag);
}

void variable_19(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Flag for refining position of critical curves \n");

  critmode = atof(fl_get_input(ob));

  printf("critmode = %g \n", critmode);
}

void variable_20(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Tolerance for finding critical curves \n");
  
  crittol = atof(fl_get_input(ob));
  
  printf("crittol = %g \n", crittol);
}

void variable_21(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("1->cartesian, 2->polar \n");
  
  galcoords = atof(fl_get_input(ob));

  printf("galcoords = %g \n", galcoords);
}

void variable_22(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("1->cartesian, 2->polar \n");

  shrcoords = atof(fl_get_input(ob));

  printf("shrcoords = %g \n", shrcoords);
}

void variable_23(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  
  printf("Maximum allowed value of the shear \n");
  
  maxshear = atof(fl_get_input(ob));
  
  printf("maxshear = %g \n", maxshear);
}

void variable_24(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  
  printf("Maximum number of registration definitions \n");

  maxrgstr = atof(fl_get_input(ob));
  
  printf("maxrgstr = %g \n", maxrgstr);
}

void variable_25(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Tolerance for src2img \n");

  xtol = atof(fl_get_input(ob));
  
  printf("xtol = %g \n", xtol);
}

void variable_26(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Tolerance for numerical integrals \n");

  inttol = atof(fl_get_input(ob));
  
  printf("inttol = %g \n", inttol);
}

void variable_27(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Flag for using catalog of source tiles \n");

  catalog = atof(fl_get_input(ob));
  
  printf("catalog = %g \n", catalog);
}

void variable_28(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Flag for whether to prevent sign flips in b's \n");

  nobflip = atof(fl_get_input(ob));

  printf("nobflip = %g \n", nobflip);
}

void variable_29(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("1->direct parameters, 2->(fint,dtheta) \n");

  intshrmode = atof(fl_get_input(ob));

  printf("intshrmode = %g \n", intshrmode);
}

void variable_30(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Seed for randum number generator \n");

  seed = atof(fl_get_input(ob));

  printf("seed = %g \n", seed);
}

void variable_31(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Matter density Omega_Matter \n");

  omega = atof(fl_get_input(ob));

  printf("omega = %g \n", omega);
}

void variable_32(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Cosmological constant Omega_Lambda \n");
  
  lambda = atof(fl_get_input(ob));

  printf("lambda = %g \n", lambda);
}

void variable_33(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  
  printf("H_0 in units of 100 km/s/Mpc \n");

  hval = atof(fl_get_input(ob));

  printf("hval = %g \n", hval);
}

void variable_34(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Uncertainty in H_0 in units of 100 km/s/Mpc \n");
  
  hvale = atof(fl_get_input(ob));

  printf("hvale = %g \n", hvale);
}

void variable_35(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("The cosmology-dependent time delay factor \n");
  
  tscale = atof(fl_get_input(ob));

  printf("tscale = %g \n", tscale);
}

void variable_36(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Extent of status reports written to screen \n");
  
  verbose = atof(fl_get_input(ob));

  printf("verbose = %g \n", verbose);
}

void variable_37(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("The lens redshift \n");

  zlens = atof(fl_get_input(ob));

  printf("zlens = %g \n", zlens);
}

void variable_38(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("The source redshift \n");
  
  zsrc = atof(fl_get_input(ob));

  printf("zsrc = %g \n", zsrc);
}

void variable_39(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Weight applied to flux constraints \n");
  
  fluxweight = atof(fl_get_input(ob));

  printf("fluxweight = %g \n", fluxweight);
}

void variable_40(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Weight applied to weak lensing constraints \n");
  
  weakweight = atof(fl_get_input(ob));

  printf("weakweight = %g \n", weakweight);
}

void variable_41(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Flag for whether to check image parities \n");

  checkparity = atof(fl_get_input(ob));

  printf("checkparity = %g \n", checkparity);
}

void variable_42(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("0->approx, 1->exact, otherwise mixed \n");

  chimode = atof(fl_get_input(ob));

  printf("chimode = %g \n", chimode);
}

void variable_43(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Flag for whether to optimize source position \n");
  
  srcmode = atof(fl_get_input(ob));
  
  printf("srcmode = %g \n", srcmode);
}

void variable_44(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("1->amoeba, 2->powell \n");
  
  optmode = atof(fl_get_input(ob));
  
  printf("optmode = %g \n", optmode);
}

void variable_45(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("1->fixed, 2->random vertices \n");
  
  vertmode = atof(fl_get_input(ob));
  
  printf("vertmode = %g \n", vertmode);
}

void variable_46(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Smallest length variation in initial simplex \n");

  xfloor = atof(fl_get_input(ob));
  
  printf("xfloor = %g \n", xfloor);
}

void variable_47(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Largest length variation in initial simplex \n");

  xceil = atof(fl_get_input(ob));
  
  printf("xceil = %g \n", xceil);
}

void variable_48(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Tolerance for optimization routine \n");

  ftol = atof(fl_get_input(ob));
  
  printf("ftol = %g \n", ftol);
}

void variable_49(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Number of times to run optimization \n");

  restart = atof(fl_get_input(ob));
  
  printf("restart = %g \n", restart);
}

void variable_50(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Penalty for being in wrong source region \n");
  
  upenalty = atof(fl_get_input(ob));
  
  printf("upenalty = %g \n", upenalty);
}

void variable_51(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Automatically set linear parameters? \n");
  
  linparms = atof(fl_get_input(ob));
  
  printf("linparms = %g \n", linparms);
}

void variable_52(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Use (0) or Ignore (1) point images \n");
  
  nopointchi = atof(fl_get_input(ob));
  
  printf("nopointchi = %g \n", nopointchi);
}

void variable_53(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Use total (0) or per point (>0) curve chisq \n");  
  
  chiperpoint = atof(fl_get_input(ob));
  
  printf("chiperpoint = %g \n", chiperpoint);
}

void variable_54(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Flag for whether to write the temp files \n");
  
  tempfiles = atof(fl_get_input(ob));

 printf("tempfiles = %g \n", tempfiles);
}

void prog_exit(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  fl_finish();
  exit(0);
}  

void grav_lenses(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  FILE *glfile;

  glfile = fopen("glfile.in", "w");

  fprintf(glfile, "%lf \n", NGALMAX);
  fprintf(glfile, "%lf \n", rscale);
  fprintf(glfile, "%lf \n", gridlo1);
  fprintf(glfile, "%lf \n", gridhi1); 
  fprintf(glfile, "%lf \n", gridlo2);
  fprintf(glfile, "%lf \n", gridhi2);
  fprintf(glfile, "%lf \n", ngrid1);
  fprintf(glfile, "%lf \n", ngrid2);
  fprintf(glfile, "%lf \n", nsubg1); 
  fprintf(glfile, "%lf \n", nsubg2);
  fprintf(glfile, "%lf \n", gridflag);
  fprintf(glfile, "%lf \n", omitcore);
  fprintf(glfile, "%lf \n", omitcrit); 
  fprintf(glfile, "%lf \n", checkgaps);
  fprintf(glfile, "%lf \n", maxlev);
  fprintf(glfile, "%lf \n", gallev); 
  fprintf(glfile, "%lf \n", imglev);
  fprintf(glfile, "%lf \n", critmode); 
  fprintf(glfile, "%lf \n", crittol); 
  fprintf(glfile, "%lf \n", galcoords);
  fprintf(glfile, "%lf \n", shrcoords);
  fprintf(glfile, "%lf \n", maxshear);
  fprintf(glfile, "%lf \n", maxrgstr);
  fprintf(glfile, "%lf \n", potflag); 
  fprintf(glfile, "%lf \n", xtol); 
  fprintf(glfile, "%lf \n", inttol); 
  fprintf(glfile, "%lf \n", catalog);
  fprintf(glfile, "%lf \n", nobflip); 
  fprintf(glfile, "%lf \n", intshrmode); 
  fprintf(glfile, "%lf \n", seed);
  fprintf(glfile, "%lf \n", omega);
  fprintf(glfile, "%lf \n", lambda); 
  fprintf(glfile, "%lf \n", hval); 
  fprintf(glfile, "%lf \n", hvale); 
  fprintf(glfile, "%lf \n", tscale); 
  fprintf(glfile, "%lf \n", zlens); 
  fprintf(glfile, "%lf \n", zsrc);
  fprintf(glfile, "%lf \n", verbose); 

  fclose(glfile);
  
  printf("glfile.in was generated with your data. \n");

  system("gravlens glfile.in &");
}

void lens_modelling(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  FILE *lmfile;

  lmfile = fopen("lmfile.in", "w");

  fprintf(lmfile, "%lf \n", NGALMAX);
  fprintf(lmfile, "%lf \n", rscale);
  fprintf(lmfile, "%lf \n", gridlo1);
  fprintf(lmfile, "%lf \n", gridhi1); 
  fprintf(lmfile, "%lf \n", gridlo2);
  fprintf(lmfile, "%lf \n", gridhi2);
  fprintf(lmfile, "%lf \n", ngrid1);
  fprintf(lmfile, "%lf \n", ngrid2);
  fprintf(lmfile, "%lf \n", nsubg1); 
  fprintf(lmfile, "%lf \n", nsubg2);
  fprintf(lmfile, "%lf \n", gridflag);
  fprintf(lmfile, "%lf \n", omitcore);
  fprintf(lmfile, "%lf \n", omitcrit); 
  fprintf(lmfile, "%lf \n", checkgaps);
  fprintf(lmfile, "%lf \n", maxlev);
  fprintf(lmfile, "%lf \n", gallev); 
  fprintf(lmfile, "%lf \n", imglev);
  fprintf(lmfile, "%lf \n", critmode); 
  fprintf(lmfile, "%lf \n", crittol); 
  fprintf(lmfile, "%lf \n", galcoords);
  fprintf(lmfile, "%lf \n", shrcoords);
  fprintf(lmfile, "%lf \n", maxshear);
  fprintf(lmfile, "%lf \n", maxrgstr);
  fprintf(lmfile, "%lf \n", potflag); 
  fprintf(lmfile, "%lf \n", xtol); 
  fprintf(lmfile, "%lf \n", inttol); 
  fprintf(lmfile, "%lf \n", catalog);
  fprintf(lmfile, "%lf \n", nobflip); 
  fprintf(lmfile, "%lf \n", intshrmode); 
  fprintf(lmfile, "%lf \n", seed);
  fprintf(lmfile, "%lf \n", omega);
  fprintf(lmfile, "%lf \n", lambda); 
  fprintf(lmfile, "%lf \n", hval); 
  fprintf(lmfile, "%lf \n", hvale); 
  fprintf(lmfile, "%lf \n", tscale); 
  fprintf(lmfile, "%lf \n", zlens); 
  fprintf(lmfile, "%lf \n", zsrc);
  fprintf(lmfile, "%lf \n", verbose); 
  fprintf(lmfile, "%lf \n", fluxweight); 
  fprintf(lmfile, "%lf \n", weakweight); 
  fprintf(lmfile, "%lf \n", checkparity); 
  fprintf(lmfile, "%lf \n", chimode); 
  fprintf(lmfile, "%lf \n", srcmode);
  fprintf(lmfile, "%lf \n", optmode); 
  fprintf(lmfile, "%lf \n", vertmode); 
  fprintf(lmfile, "%lf \n", xfloor); 
  fprintf(lmfile, "%lf \n", xceil); 
  fprintf(lmfile, "%lf \n", ftol);
  fprintf(lmfile, "%lf \n", restart); 
  fprintf(lmfile, "%lf \n", upenalty);
  fprintf(lmfile, "%lf \n", linparms);
  fprintf(lmfile, "%lf \n", nopointchi); 
  fprintf(lmfile, "%lf \n", chiperpoint); 
  fprintf(lmfile, "%lf \n", tempfiles);

  fclose(lmfile);
  
  printf("lmfile.in was generated with your data. \n");

  system("lensmodel lmfile.in &");
}

void viewing(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Not yet implemented \n");
}

void variable_reset(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  
  fl_set_input(fd_Keeton->var_1, "20.0");
  fl_set_input(fd_Keeton->var_2, "1.0");
  fl_set_input(fd_Keeton->var_3, "0.0");
  fl_set_input(fd_Keeton->var_4, "2.0");
  fl_set_input(fd_Keeton->var_5, "0.0");
  fl_set_input(fd_Keeton->var_6, "360.0");
  fl_set_input(fd_Keeton->var_7, "20.0");
  fl_set_input(fd_Keeton->var_8, "20.0");
  fl_set_input(fd_Keeton->var_9, "1.0");

  NGALMAX  = 20.0; 
  rscale   = 1.0;
  gridlo1  = 0.0;
  gridhi1  = 2.0; 
  gridlo2  = 0.0;
  gridhi2  = 360.0;
  ngrid1   = 20.0;
  ngrid2   = 20.0;
  gridflag = 1.0;

  fl_set_input(fd_Keeton->var_10, "2.0");
  fl_set_input(fd_Keeton->var_11, "2.0");
  fl_set_input(fd_Keeton->var_12, "0.0");
  fl_set_input(fd_Keeton->var_13, "500.0");
  fl_set_input(fd_Keeton->var_14, "1.0");
  fl_set_input(fd_Keeton->var_15, "3.0");
  fl_set_input(fd_Keeton->var_16, "3.0");
  fl_set_input(fd_Keeton->var_17, "3.0");
  fl_set_input(fd_Keeton->var_18, "1.0");

  nsubg1    = 2.0;
  nsubg2    = 2.0;
  omitcore  = 0.0;
  omitcrit  = 500.0;
  checkgaps = 1.0;
  maxlev    = 3.0;
  gallev    = 3.0;
  imglev    = 3.0;
  potflag   = 1.0;

  fl_set_input(fd_Keeton->var_19, "1.0");
  fl_set_input(fd_Keeton->var_20, "0.000001");
  fl_set_input(fd_Keeton->var_21, "1.0");
  fl_set_input(fd_Keeton->var_22, "2.0");
  fl_set_input(fd_Keeton->var_23, "1.0");
  fl_set_input(fd_Keeton->var_24, "5.0");
  fl_set_input(fd_Keeton->var_25, "0.000001");
  fl_set_input(fd_Keeton->var_26, "0.000001");
  fl_set_input(fd_Keeton->var_27, "0.0");

  critmode  = 1.0;
  crittol   = 0.000001;
  galcoords = 1.0;
  shrcoords = 2.0;
  maxshear  = 1.0;
  maxrgstr  = 5.0;
  xtol      = 00000001;
  inttol    = 0.000001;
  catalog   = 0.0;

  fl_set_input(fd_Keeton->var_28, "0.0");
  fl_set_input(fd_Keeton->var_29, "1.0");
  fl_set_input(fd_Keeton->var_30, "-15.0");
  fl_set_input(fd_Keeton->var_31, "1.0");
  fl_set_input(fd_Keeton->var_32, "0.0");
  fl_set_input(fd_Keeton->var_33, "1.0");
  fl_set_input(fd_Keeton->var_34, "0.1");
  fl_set_input(fd_Keeton->var_35, "1.0");
  fl_set_input(fd_Keeton->var_36, "1.0");

  nobflip    = 0.0;
  intshrmode = 1.0;
  seed       = -15.0;
  omega      = 1.0;
  lambda     = 0.0;
  hval       = 1.0;
  hvale      = 0.1;
  tscale     = 1.0;
  verbose    = 1.0;

  fl_set_input(fd_Keeton->var_37, "-1.0");
  fl_set_input(fd_Keeton->var_38, "-1.0");
  fl_set_input(fd_Keeton->var_39, "1.0");
  fl_set_input(fd_Keeton->var_40, "1.0");
  fl_set_input(fd_Keeton->var_41, "1.0");
  fl_set_input(fd_Keeton->var_42, "1.0");
  fl_set_input(fd_Keeton->var_43, "1.0");
  fl_set_input(fd_Keeton->var_44, "1.0");
  fl_set_input(fd_Keeton->var_45, "1.0");

  zlens       = -1.0;
  zsrc        = -1.0;
  fluxweight  = 1.0;
  weakweight  = 1.0;
  checkparity = 1.0;
  chimode     = 1.0;
  srcmode     = 1.0;
  optmode     = 1.0;
  vertmode    = 1.0;

  fl_set_input(fd_Keeton->var_46, "0.005");
  fl_set_input(fd_Keeton->var_47, "0.1");
  fl_set_input(fd_Keeton->var_48, "0.0001");
  fl_set_input(fd_Keeton->var_49, "1.0");
  fl_set_input(fd_Keeton->var_50, "0.0001");
  fl_set_input(fd_Keeton->var_51, "0.0");
  fl_set_input(fd_Keeton->var_52, "0.0");
  fl_set_input(fd_Keeton->var_53, "0.0");
  fl_set_input(fd_Keeton->var_54, "1.0");

  xfloor      = 0.005;
  xceil       = 0.1;
  ftol        = 0.0001;
  restart     = 1.0;
  upenalty    = 0.0001;
  linparms    = 0.0;
  nopointchi  = 0.0; 
  chiperpoint = 0.0;
  tempfiles   = 1.0;
}

void variable_set(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  
  FILE *file;

  file = fopen("file.in", "w");

  fprintf(file, "%lf \n", NGALMAX);
  fprintf(file, "%lf \n", rscale);
  fprintf(file, "%lf \n", gridlo1);
  fprintf(file, "%lf \n", gridhi1); 
  fprintf(file, "%lf \n", gridlo2);
  fprintf(file, "%lf \n", gridhi2);
  fprintf(file, "%lf \n", ngrid1);
  fprintf(file, "%lf \n", ngrid2);
  fprintf(file, "%lf \n", nsubg1); 
  fprintf(file, "%lf \n", nsubg2);
  fprintf(file, "%lf \n", gridflag);
  fprintf(file, "%lf \n", omitcore);
  fprintf(file, "%lf \n", omitcrit); 
  fprintf(file, "%lf \n", checkgaps);
  fprintf(file, "%lf \n", maxlev);
  fprintf(file, "%lf \n", gallev); 
  fprintf(file, "%lf \n", imglev);
  fprintf(file, "%lf \n", critmode); 
  fprintf(file, "%lf \n", crittol); 
  fprintf(file, "%lf \n", galcoords);
  fprintf(file, "%lf \n", shrcoords);
  fprintf(file, "%lf \n", maxshear);
  fprintf(file, "%lf \n", maxrgstr);
  fprintf(file, "%lf \n", potflag); 
  fprintf(file, "%lf \n", xtol); 
  fprintf(file, "%lf \n", inttol); 
  fprintf(file, "%lf \n", catalog);
  fprintf(file, "%lf \n", nobflip); 
  fprintf(file, "%lf \n", intshrmode); 
  fprintf(file, "%lf \n", seed);
  fprintf(file, "%lf \n", omega);
  fprintf(file, "%lf \n", lambda); 
  fprintf(file, "%lf \n", hval); 
  fprintf(file, "%lf \n", hvale); 
  fprintf(file, "%lf \n", tscale); 
  fprintf(file, "%lf \n", zlens); 
  fprintf(file, "%lf \n", zsrc);
  fprintf(file, "%lf \n", verbose); 
  fprintf(file, "%lf \n", fluxweight); 
  fprintf(file, "%lf \n", weakweight); 
  fprintf(file, "%lf \n", checkparity); 
  fprintf(file, "%lf \n", chimode); 
  fprintf(file, "%lf \n", srcmode);
  fprintf(file, "%lf \n", optmode); 
  fprintf(file, "%lf \n", vertmode); 
  fprintf(file, "%lf \n", xfloor); 
  fprintf(file, "%lf \n", xceil); 
  fprintf(file, "%lf \n", ftol);
  fprintf(file, "%lf \n", restart); 
  fprintf(file, "%lf \n", upenalty);
  fprintf(file, "%lf \n", linparms);
  fprintf(file, "%lf \n", nopointchi); 
  fprintf(file, "%lf \n", chiperpoint); 
  fprintf(file, "%lf \n", tempfiles);

  fclose(file);
  
  printf("file.in was generated with your data. \n");
}




